
from pmbm import GaussianTransitionDensity, GaussianBirthParametrization

import numpy as np
import scipy as sp

from dataspree.inference.plugins.tracking.sigma_point_integration import compute_sigma_point_integral


class GLMB:


    def __init__(self, birth_model: GaussianBirthParametrization, h_max: int,
                 transition_model: GaussianTransitionDensity,
                 poisson_clutter, detection_probability: float = 0.9):

        self.birth_model: GaussianBirthParametrization = birth_model
        self.transition_model: GaussianTransitionDensity = transition_model
        self.max_number_of_hypothesis: int = h_max

        self.weights : np.ndarray = np.empty(h_max)
        self.active_labels: np.ndarray = np.empty((self.max_number_of_hypothesis, h_max))

        self.means = ...
        self.cov = ...

        self.number_of_hypothesis: int = 0

        self.current_time_index: int = 0
        ...


    def tic(self, time: float, z: np.ndarray):

        self.current_time_index += 1


        M = z.shape[0]
        np.random.multinomial(self.max_number_of_hypothesis, self.weights[:self.number_of_hypothesis])

        p_ = compute_sigma_point_integral(means=self.means, covs=self.cov)

        for h in range(1, self.number_of_hypothesis):
            P = self.active_labels[h].shape[0]

            # i in (0, |I^h \cap B_+|)
            # j in -1, 0, ... M
            cost_matrix = np.empty()



            # XXX: initialize the initial assignment to z
            gamma_0 = sp.optimize.linear_sum_assignment()



            assi
        ...

